local amb = 0
local ambTimer = 0
local ambAmount = 10
local ambSpeed = 5
local dolighting = true
local lightAm = 0.25
local lightMax = 0.2
local lightMin = 0.3
local lightSpeed = 0.5
local lightTimer = 0
function light_update(dt)
	ambTimer = ambTimer + ambSpeed * dt
	if(ambTimer > 10) then
		ambTimer = ambTimer-20 + ambSpeed * dt
	end
	amb = math.cos(ambTimer) * ambAmount
	
	lightTimer = lightTimer + lightSpeed * dt
	if(lightTimer > 10) then
		lightTimer = lightTimer-20 + lightSpeed * dt
	end
	
	lightAm = math.abs(math.cos(lightTimer)) * lightMin + lightMax
end

lightImg = love.graphics.newImage("gfx/light.png")

function lighting()
	if(dolighting == true) then
		love.graphics.setColor(255,0,0)
		love.graphics.setStencil(function()
			love.graphics.circle("fill",player.x + cam.x,player.y + cam.y,400 + amb)
			for i,v in ipairs(en) do
				if(v.x + 100 > -cam.x and v.y + 100 > -cam.y and v.x - 100 < -cam.x + screen.w and v.y - 100 < -cam.y + screen.h) then
					love.graphics.circle("fill",v.x + cam.x,v.y + cam.y,100 - amb)
				end
			end
			
			for i,v in ipairs(bullets) do
				if(v.x + 100 > -cam.x and v.y + 100 > -cam.y and v.x - 100 < -cam.x + screen.w and v.y - 100 < -cam.y + screen.h and CheckDist(v.x,v.y,player.x,player.y)>400) then
					love.graphics.circle("fill",v.x + cam.x,v.y + cam.y,50 - amb)
					--love.graphics.draw(lightImg,v.x+cam.x-50,v.y+cam.y-50)
				end		
			end
		end)
		love.graphics.setColor(255,255,255)
	end
end

function lighting_2()
	love.graphics.setColor(0,0,0,lightAm * 255)
	love.graphics.rectangle("fill",0,0,screen.w,screen.h)
	love.graphics.setColor(255,255,255)
end
