

function map_load()
	rooms = {}

	gen(10,{4,8})
end

stairs = {}
stairs.check = true

timeBonus = 0
function map_update(dt)
	if(CheckCollision(stairs.x,stairs.y,100,100,player.x,player.y,32,52) and stairs.check == true) then
		stairs.check = false
		fade("next")
		if(gameTime < (50+10*floorNum)) then
			local y = ((50+10*floorNum) - gameTime)
			timeBonus = y * 100
			score = math.floor(score + y * 100)
		end
		gameTime = 0
	end
end

floorNum = 1

function gen(s,rs)
	math.randomseed = os.time
	local x = 0
	local y = 0
	local w = math.random(rs[1],rs[2])*100
	local h = math.random(rs[1],rs[2])*100
	ro = {}
	ro.x = x
	ro.y = y
	ro.w = w
	ro.h = h
	
	ro.doors = {}
	local dir = math.random(2,3) -- 1:up, 2:right, 3:down, 4:left
	local doorType = math.random(1,2) -- 1:small, 2: big
	if(dir == 1) then
		ro.doors.top = {}
		if(doorType == 1) then
			ro.doors.top.x = w/2 - 100
			ro.doors.top.w = 200
		else
			ro.doors.top.x = 0
			ro.doors.top.w = w
		end
		
		y = y - h
	elseif(dir == 2) then
		ro.doors.right = {}
		if(doorType == 1) then
			ro.doors.right.y = h/2 - 100
			ro.doors.right.h = 200
		else
			ro.doors.right.y = 0
			ro.doors.right.h = h
		end	
		
		x = x + w
	elseif(dir == 3) then
		ro.doors.bot = {}
		if(doorType == 1) then
			ro.doors.bot.x = w/2 - 100
			ro.doors.bot.w = 200
		else
			ro.doors.bot.x = 0
			ro.doors.bot.w = w
		end
		
		y = y + h
	else -- 4
		ro.doors.left = {}
		if(doorType == 1) then
			ro.doors.left.y = h/2 - 100
			ro.doors.left.h = 200
		else
			ro.doors.left.y = 0
			ro.doors.left.h = h
		end	

		--x = x - w
	end
	table.insert(rooms,ro)
	
	local lastDir = dir
	for i=1,s do
		local lastw = w
		local lasth = h
		w = math.random(rs[1],rs[2])*100
		h = math.random(rs[1],rs[2])*100
		ro = {}
		ro.doors = {}
		if(dir == 1) then -- 1:up, 2:right, 3:down, 4:left -- 1:small, 2: big
			w = lastw
			ro.doors.bot = {}
			if(doorType == 1) then
				ro.doors.bot.x = w/2 - 100
				ro.doors.bot.w = 200
			else
				ro.doors.bot.x = 0
				ro.doors.bot.w = w
			end	
			
			y = y - h
		elseif(dir == 2) then
			h = lasth
			ro.doors.left = {}
			if(doorType == 1) then
				ro.doors.left.y = h/2 - 100
				ro.doors.left.h = 200
			else
				ro.doors.left.y = 0
				ro.doors.left.h = h
			end	
			
		elseif(dir == 3) then
			w = lastw
			ro.doors.top = {}
			if(doorType == 1) then
				ro.doors.top.x = w/2 - 100
				ro.doors.top.w = 200
			else
				ro.doors.top.x = 0
				ro.doors.top.w = w
			end
		elseif(dir == 4) then -- 4
			h = lasth
			ro.doors.right = {}
			if(doorType == 1) then
				ro.doors.right.y = h/2 - 100
				ro.doors.right.h = 200
			else
				ro.doors.right.y = 0
				ro.doors.right.h = h
			end	
			x = x - w
		end
		
		ro.y = y
		ro.x = x
		ro.w = w
		ro.h = h
		
		if(i ~= s) then
		if(lastDir ~= 2) then
			if(lastDir == 1) then
				dir = math.random(1,2)
			else
				dir = math.random(2,3) -- 1:up, 2:right, 3:down, 4:left
			end
		else
			dir = math.random(1,3)
		end
		doorType = math.random(1,2) -- 1:small, 2: big
		if(dir == 1) then
			ro.doors.top = {}
			if(doorType == 1) then
				ro.doors.top.x = w/2 - 100
				ro.doors.top.w = 200
			else
				ro.doors.top.x = 0
				ro.doors.top.w = w
			end
			
			--y = y - h
		elseif(dir == 2) then
			ro.doors.right = {}
			if(doorType == 1) then
				ro.doors.right.y = h/2 - 100
				ro.doors.right.h = 200
			else
				ro.doors.right.y = 0
				ro.doors.right.h = h
			end	
			
			x = x + w
		elseif(dir == 3) then
			ro.doors.bot = {}
			if(doorType == 1) then
				ro.doors.bot.x = w/2 - 100
				ro.doors.bot.w = 200
			else
				ro.doors.bot.x = 0
				ro.doors.bot.w = w
			end
			
			y = y + h
		else -- 4
			ro.doors.left = {}
			if(doorType == 1) then
				ro.doors.left.y = h/2 - 100
				ro.doors.left.h = 200
			else
				ro.doors.left.y = 0
				ro.doors.left.h = h
			end	

			--x = x - w
		end
		decorate(ro,lastDir,dir,doorType)
		lastDir = dir
		
		
		end
		
		if not(i==s) then
			for j=1,math.random(2,6) do	
				local randomX = math.random(ro.x + wall_w*2, ro.x + ro.w - wall_w*2)
				local randomY = math.random(ro.y + wall_w*2, ro.y + ro.h - wall_w*2)
				en_spawn(randomX,randomY)
			end
		else
			-- 1:up, 2:right, 3:down, 4:left
			if(dir == 3 or dir == 4) then
				stairs.x = ro.x
				stairs.y = ro.y + ro.h - 200
			else
				stairs.x = ro.x + ro.w - 200
				stairs.y = ro.y
			end
		end
		
		
		table.insert(rooms,ro)
		
	end
	
end

function load_next()
	local lastS = #rooms
	player.x = 200
	player.y = 200
	player.xvel = 0
	player.yvel = 0
	player.hp = 10

	floorNum = floorNum + 1
	
	combo = 0
	
	for i=#rooms,1,-1 do
		table.remove(rooms,i)
	end
	blood_reset()
	for i=#bodies,1,-1 do
		table.remove(bodies,i)
	end
	for i=#trail,1,-1 do
		table.remove(trail,i)
	end
	for i=#bullets,1,-1 do
		table.remove(bullets,i)
	end
	for i=#enBullets,1,-1 do
		table.remove(enBullets,i)
	end
	en_reset()

	cam.tx = -player.x +screen.w/2
	cam.ty = -player.y + screen.h/2
	cam.x = cam.tx
	cam.y = cam.ty

	
	items_reset(false)
	decor_reset()
	stairs.check = true
	gen(lastS + 1,{4,8})
end

function reset()
	player.xvel = 0
	player.yvel = 0
	player.x = 200
	player.y = 200
	player.hp = 10
	score = 0
	combo = 0
	floorNum = 1
	gameTime = 0
	for i=#rooms,1,-1 do
		table.remove(rooms,i)
	end
	blood_reset()
	for i=#bodies,1,-1 do
		table.remove(bodies,i)
	end
	for i=#trail,1,-1 do
		table.remove(trail,i)
	end
	for i=#trails,1,-1 do
		table.remove(trails,i)
	end
	for i=#bullets,1,-1 do
		table.remove(bullets,i)
	end
	for i=#enBullets,1,-1 do
		table.remove(enBullets,i)
	end
	en_reset()
	for i=#trails,1,-1 do
		table.remove(trails,i)
	end
	items_reset(true)
	decor_reset()
	stairs.check = true
	gen(10,{4,8})
end

mapW = 10
mapH = 4
roomS = {5,15}

wall_w = 30 -- wall width

function map_col(x,y,dx,dy,dt)
	for i,v in ipairs(rooms) do
		if(v.doors.top) then
			if(v.doors.top.w ~= v.w) then
				--x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x,v.y,v.doors.top.x,wall_w,dt)
				--x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x+v.doors.top.x+v.doors.top.w,v.y,v.w-v.doors.top.w-v.doors.top.x,wall_w,dt)
			end
		else
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x,v.y,v.w,wall_w,dt)
		end
		
		if(v.doors.bot) then
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x,v.y+v.h,v.doors.bot.x,wall_w*2,dt)
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x+v.doors.bot.x+v.doors.bot.w,v.y+v.h,v.w-v.doors.bot.w-v.doors.bot.x,wall_w*2,dt)
		else
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x,v.y + v.h - wall_w,v.w,wall_w,dt)
		end
		
		if(v.doors.right) then
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x+v.w,v.y,wall_w,v.doors.right.y + wall_w,dt)
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x+v.w,v.y+v.doors.right.y+v.doors.right.h,wall_w,v.h-v.doors.right.h-v.doors.right.y,dt)
		else
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x+v.w,v.y ,wall_w,v.h,dt)
		end
		
		if(v.doors.left) then
		
		else
			x,y,dx,dy = hitbox_col2(x,y,dx,dy,v.x,v.y ,wall_w,v.h,dt)
		end
	end
	
	return x,y,dx,dy
end

local floorT = love.graphics.newImage("gfx/floor.png")

function map_draw()
	for i,v in ipairs(rooms) do
		if(v.x + v.w > -cam.x and v.y + v.h > -cam.y and v.x - v.w < -cam.x + screen.w and v.y - v.h < -cam.y + screen.h) then	
		--love.graphics.setColor(100,100,100)
		
		for y=0,v.h/roof.ts -1 do
			for x=0,v.w/roof.ts -1 do
				if(y % 2 == 0) then
					c = x + 1
				else
					c = x
				end
				if(c % 2 == 0) then
					--love.graphics.setColor(50,50,50)
				else
					--love.graphics.setColor(100,100,100)
				end
				--love.graphics.rectangle("fill",v.x + x*roof.ts,v.y + y*roof.ts,roof.ts,roof.ts)
				love.graphics.draw(floorT,v.x + x*roof.ts,v.y + y*roof.ts)
			end
		end
		
		love.graphics.setColor(255,255,255)
		
		
		--love.graphics.rectangle("line",v.x,v.y,v.w,v.h)

		end
	end
	
	love.graphics.draw(stairimg,stairs.x,stairs.y)
end

stairimg = love.graphics.newImage("gfx/stairs.png")

function map2_draw()
	love.graphics.setColor(0,0,100)
	for i,v in ipairs(rooms) do
		if(v.x + v.w > -cam.x and v.y + v.h > -cam.y and v.x - v.w < -cam.x + screen.w and v.y - v.h < -cam.y + screen.h) then	
		if(v.doors.top) then
			love.graphics.rectangle("fill",v.x,v.y+wall_w,v.doors.top.x,wall_w)
			love.graphics.rectangle("fill",v.x + v.doors.top.x + v.doors.top.w,v.y+wall_w,v.w - v.doors.top.x - v.doors.top.w,wall_w)
		else
			love.graphics.rectangle("fill",v.x,v.y,v.w,wall_w)
		end
		
		if(v.doors.bot) then
	
		else
			love.graphics.rectangle("fill",v.x,v.y + v.h,v.w+30,30)
		end
		
		if(v.doors.right) then

		else
			love.graphics.rectangle("fill",v.x+v.w,v.y - 60+v.h+30,30,30)
		end
		
		if(v.doors.left) then
			love.graphics.rectangle("fill",v.x,v.y-30 + v.h+30 - v.doors.left.y - v.doors.left.h,wall_w,wall_w)
		else
		
		end
		end
	end
	love.graphics.setColor(255,255,255)
end

function map3_draw()
	love.graphics.setColor(50,50,50)
	for i,v in ipairs(rooms) do
		if(v.x + v.w > -cam.x and v.y + v.h > -cam.y and v.x - v.w < -cam.x + screen.w and v.y - v.h < -cam.y + screen.h) then	
		if(v.doors.top) then
			love.graphics.rectangle("fill",v.x,v.y,v.doors.top.x,wall_w)
			love.graphics.rectangle("fill",v.x + v.doors.top.x + v.doors.top.w,v.y,v.w - v.doors.top.x - v.doors.top.w,wall_w)
		else
			love.graphics.rectangle("fill",v.x,v.y - wall_w,v.w,wall_w)
		end
		
		if(v.doors.bot) then
		
		else
			love.graphics.rectangle("fill",v.x,v.y + v.h - 30,v.w + 30,30)	
		end
		
		if(v.doors.right) then

		else
			love.graphics.rectangle("fill",v.x+v.w,v.y - 30,wall_w,v.h)

		end
		
		if(v.doors.left) then
			love.graphics.rectangle("fill",v.x,v.y-30,30,v.h+30 - v.doors.left.y - v.doors.left.h)
			love.graphics.rectangle("fill",v.x,v.y + v.doors.left.y + v.doors.left.h,30,v.h - v.doors.left.y - v.doors.left.h)
		else
			love.graphics.rectangle("fill",v.x,v.y-30,30,v.h+30)
		end
		end
	end
	love.graphics.setColor(255,255,255)
end
