state = "menu"

function gameover_update(dt)
	pinhole_update(dt)
end

function gameover_draw()
	pinhole_draw()
	
	love.graphics.setFont(font2)
	local text = "GAME OVER"
	local tw = font2:getWidth(text)
	love.graphics.print(text,screen.w/2 - tw/2,screen.h/2 - 35)
	
	
	love.graphics.setFont(font1)
	
	text = "Score: "..score
	tw = font1:getWidth(text)
	love.graphics.print(text,screen.w/2 - tw/2,screen.h/2)	
	
	text = "Press Space to Try Again"
	tw = font1:getWidth(text)
	love.graphics.print(text,screen.w/2 - tw/2,screen.h/2 + 50)
end

function gameover_keypress(key)
	if(key == " ") then
		holeS = love.window.getHeight()/50
		reset()
		state = "play"
	end
end

function gamePause_draw()
	love.graphics.setFont(font2)
	local text = "PAUSED"
	local tw = font2:getWidth(text)
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",screen.w/2-tw/2-20,100,tw + 40,50)
	love.graphics.setColor(255,255,255)
	love.graphics.print(text,screen.w/2-tw/2+5,110)
	love.graphics.setFont(font1)
	
	text = "Q: quit"
	tw = font1:getWidth(text)
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",screen.w/2-tw/2-10,200,tw + 20,30)
	love.graphics.setColor(255,255,255)
	love.graphics.print(text,screen.w/2-tw/2+4,210)
end

function gamePause_keypress(key)
	if(key == "q") then
		love.event.quit()
	end
end
local starting = false
function menu_update(dt)
	if(starting == true and fadeIn == false) then
		state = "play"
		starting = false
	end
end

function menu_draw()
	love.graphics.setFont(font2)
	local text = ("DEAD OFFICE")
	local tw = font2:getWidth(text)
	love.graphics.print(text,screen.w/2-tw/2,100)
	love.graphics.setFont(font1)
	local text = ("Space to Play")
	local tw = font1:getWidth(text)
	love.graphics.print(text,screen.w/2-tw/2,300)
end



function menu_keypress(key)
	if(key == " " and starting == false) then
		starting = true
		fade()
	end
end